// --------- This code has been automatically generated !!! 2018-04-16T04:56:42.163Z
"use strict";
/**
 * @module opcua.address_space.types
 */
const assert = require("node-opcua-assert").assert;
const util = require("util");
const _  = require("underscore");
const makeNodeId = require("node-opcua-nodeid").makeNodeId;
const schema_helpers =  require("node-opcua-factory/src/factories_schema_helpers");
const extract_all_fields                       = schema_helpers.extract_all_fields;
const resolve_schema_field_types               = schema_helpers.resolve_schema_field_types;
const initialize_field                         = schema_helpers.initialize_field;
const initialize_field_array                   = schema_helpers.initialize_field_array;
const check_options_correctness_against_schema = schema_helpers.check_options_correctness_against_schema;
const _defaultTypeMap = require("node-opcua-factory/src/factories_builtin_types")._defaultTypeMap;
const ec = require("node-opcua-basic-types");
const encodeArray = ec.encodeArray;
const decodeArray = ec.decodeArray;
const makeExpandedNodeId = require("node-opcua-nodeid/src/expanded_nodeid").makeExpandedNodeId;
const generate_new_id = require("node-opcua-factory").generate_new_id;
const _enumerations = require("node-opcua-factory/src/factories_enumerations")._private._enumerations;
const schema = require("../schemas/DeleteNodesRequest_schema").DeleteNodesRequest_Schema;
const getFactory = require("node-opcua-factory/src/factories_factories").getFactory;
const RequestHeader = getFactory("RequestHeader");
const DeleteNodesItem = require("./_auto_generated_DeleteNodesItem").DeleteNodesItem;
const BaseUAObject = require("node-opcua-factory/src/factories_baseobject").BaseUAObject;

/**
 * 
 * @class DeleteNodesRequest
 * @constructor
 * @extends BaseUAObject
 * @param  options {Object}
 */
function DeleteNodesRequest(options)
{
    options = options || {};
    /* istanbul ignore next */
    if (schema_helpers.doDebug) { check_options_correctness_against_schema(this,schema,options); }
    const self = this;
    assert(this instanceof BaseUAObject); //  ' keyword "new" is required for constructor call')
    resolve_schema_field_types(schema);

    BaseUAObject.call(this,options);
    if (options === null) { 
        BaseUAObject.call(this,options);
        self.requestHeader =  null; /* new RequestHeader(null); */
        self.nodesToDelete =  null; /* null array */
        return ;
    }

    /**
      * A standard header included in all requests sent to a server.
      * @property requestHeader
      * @type {RequestHeader}
      */
    self.requestHeader =  new RequestHeader( options.requestHeader);

    /**
      *  
      * @property nodesToDelete
      * @type {DeleteNodesItem[]}
      */
    self.nodesToDelete = [];
    if (options.nodesToDelete) {
        assert(_.isArray(options.nodesToDelete));
        self.nodesToDelete = options.nodesToDelete.map(function(e){ return new DeleteNodesItem(e); } );
    }

   // Object.preventExtensions(self);
}
util.inherits(DeleteNodesRequest,BaseUAObject);
DeleteNodesRequest.prototype.encodingDefaultBinary = makeExpandedNodeId(500,0);
DeleteNodesRequest.prototype.encodingDefaultXml = makeExpandedNodeId(499,0);
DeleteNodesRequest.prototype._schema = schema;

/**
 * encode the object into a binary stream
 * @method encode
 *
 * @param stream {BinaryStream} 
 */
DeleteNodesRequest.prototype.encode = function(stream,options) {
    // call base class implementation first
    BaseUAObject.prototype.encode.call(this,stream,options);
   this.requestHeader.encode(stream,options);
    encodeArray(this.nodesToDelete,stream,function(obj,stream){ obj.encode(stream,options); }); 
};
/**
 * decode the object from a binary stream
 * @method decode
 *
 * @param stream {BinaryStream} 
 */
DeleteNodesRequest.prototype.decode = function(stream) {
    // call base class implementation first
    BaseUAObject.prototype.decode.call(this,stream);
    this.requestHeader.decode(stream);
    this.nodesToDelete = decodeArray(stream, function(stream) { 
       const obj = new DeleteNodesItem(null);
       obj.decode(stream);
       return obj; 
    });
};
DeleteNodesRequest.possibleFields = [
  "requestHeader",
         "nodesToDelete"
];


exports.DeleteNodesRequest = DeleteNodesRequest;
const register_class_definition = require("node-opcua-factory/src/factories_factories").register_class_definition;
register_class_definition("DeleteNodesRequest",DeleteNodesRequest);
